# Photoshop Image Modes implementation

| `pb->imageMode`            | PIPL.r `'mode'` (Big Endian)                    | JSON PiPL "SupportedModes" | PSHOP_ImageMode "EnableInfo" (JSON), `'enbl'` (PIPL.r) | PSHOP_ImageDepth "EnableInfo" (JSON), `'enbl'` (PIPL.r) | Color Channels (no Alpha) | Annotation                                                       | Filter Foundry support | Filter Foundry channel names |
| -------------------------- | ----------------------------------------------- | -------------------------- | ------------------------------------------------------ | ------------------------------------------------------- | ------------------------- | ---------------------------------------------------------------- | ---------------------- | ---------------------------- |
| plugInModeBitmap           | noBitmap, doesSupportBitmap (bit 0)             | Bitmap                     | BitmapMode                                             | 1 ?                                                     | 1                         | `'mode'` and `'enbl'` are ignored! (*)                           | No                     | I                            |
| plugInModeGrayScale        | noGrayScale, doesSupportGrayScale (bit 1)       | GrayScale                  | GrayScaleMode                                          | 8                                                       | 1                         |                                                                  | Yes                    | KA                           |
| plugInModeIndexedColor     | noIndexedColor, doesSupportIndexedColor (bit 2) | IndexedColor               | IndexedColorMode                                       | 8                                                       | 1                         | `'mode'` and `'enbl'` are ignored! (*)                           | No                     | I                            |
| plugInModeRGBColor         | noRGBColor, doesSupportRGBColor (bit 3)         | RGBColor                   | RGBMode                                                | 8                                                       | 3                         |                                                                  | Yes                    | RGBA                         |
| plugInModeCMYKColor        | noCMYKColor, doesSupportCMYKColor (bit 4)       | CMYKColor                  | CMYKMode                                               | 8                                                       | 4                         |                                                                  | Yes                    | CMYK                         |
| plugInModeHSLColor         | noHSLColor, doesSupportHSLColor (bit 5)         | HSLColor                   | HSLMode                                                | 8                                                       | 3                         | How to select that?                                              | Yes                    | HSL                          |
| plugInModeHSBColor         | noHSBColor, doesSupportHSBColor (bit 6)         | HSBColor                   | HSBMode                                                | 8                                                       | 3                         | How to select that?                                              | Yes                    | HSB                          |
| plugInModeMultichannel     | noMultichannel, doesSupportMultichannel (bit 7) | Multichannel               | MultichannelMode                                       | 8                                                       | variable                  |                                                                  | Yes                    | 1234                         |
| plugInModeDuotone          | noDuotone, doesSupportDuotone (bit 8)           | Duotone                    | DuotoneMode                                            | 8                                                       | 1                         |                                                                  | Yes                    | DA                           |
| plugInModeLabColor         | noLABColor, doesSupportLABColor (bit 9)         | LABColor                   | LabMode                                                | 8                                                       | 3                         |                                                                  | Yes                    | LabA                         |
| plugInModeGray16           | Bit 10 (undocumented)                           | (None)                     | Gray16Mode                                             | 16                                                      | 1                         |                                                                  | Yes                    | KA                           |
| plugInModeRGB48            | Bit 11 (undocumented)                           | (None)                     | RGB48Mode                                              | 16                                                      | 3                         |                                                                  | Yes                    | RGBA                         |
| plugInModeLab48            | Bit 12 (undocumented)                           | (None)                     | Lab48Mode                                              | 16                                                      | 3                         |                                                                  | Yes                    | LabA                         |
| plugInModeCMYK64           | Bit 13 (undocumented)                           | (None)                     | CMYK64Mode                                             | 16                                                      | 4                         |                                                                  | Yes                    | CMYK                         |
| plugInModeDeepMultichannel | Bit 14 (undocumented)                           | (None)                     | DeepMultichannelMode                                   | 16                                                      | variable                  |                                                                  | Yes                    | 1234                         |
| plugInModeDuotone16        | Bit 15 (undocumented)                           | (None)                     | Duotone16Mode                                          | 16                                                      | 1                         | How to select that? (In PS 2025 you can only select 8bit Duplex) | Yes                    | DA                           |
| plugInModeRGB96            | Bit 16 (undocumented)                           | (None)                     | RGB96Mode                                              | 32                                                      | 3                         |                                                                  | Yes                    | RGBA                         |
| plugInModeGray32           | Bit 17 (undocumented)                           | (None)                     | Gray32Mode                                             | 32                                                      | 1                         |                                                                  | Yes                    | KA                           |

(*) Bitmap and IndexedColor can be enabled with "enbl" set to "true" (not with adding BitmapMode and IndexedColorMode). But starting the filter shows
"Could not complete the Filter Foundry command because the filter module does not work with single channel images."
This seems to be nonsense, because PluginMain() is not even called!
